Attribute VB_Name = "modFTPDLL"

Global hOpen          As Long

Public Const scUserAgent = "vb wininet"
Public Const INTERNET_OPEN_TYPE_DIRECT = 1
Public Const INTERNET_INVALID_PORT_NUMBER = 0
Public Const INTERNET_SERVICE_FTP = 1
Public Const INTERNET_FLAG_RELOAD = &H80000000

Public Const INTERNET_FLAG_RESYNCHRONIZE = &H800
Public Const MAX_PATH = 260

Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Type WIN32_FIND_DATA
        dwFileAttributes    As Long
        ftCreationTime      As FILETIME
        ftLastAccessTime    As FILETIME
        ftLastWriteTime     As FILETIME
        nFileSizeHigh       As Long
        nFileSizeLow        As Long
        dwReserved0         As Long
        dwReserved1         As Long
        cFileName           As String * MAX_PATH
        cAlternate          As String * 14
End Type

Public Declare Function FtpFindFirstFile Lib "wininet.dll" Alias "FtpFindFirstFileA" _
    (ByVal hFtpSession As Long, ByVal lpszSearchFile As String, _
    lpFindFileData As WIN32_FIND_DATA, ByVal dwFlags As Long, ByVal dwContent As Long) As Long

' Initializes an application's use of the Win32 Internet functions
Public Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" _
    (ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, _
    ByVal sProxyBypass As String, ByVal lFlags As Long) As Long

' Closes a single Internet handle or a subtree of Internet handles.
Public Declare Function InternetCloseHandle Lib "wininet.dll" _
    (ByVal hInet As Long) As Integer

' Opens a FTP session for a given site.
Public Declare Function InternetConnect Lib "wininet.dll" Alias "InternetConnectA" _
    (ByVal hInternetSession As Long, ByVal sServerName As String, ByVal nServerPort As Integer, _
    ByVal sUserName As String, ByVal sPassWord As String, ByVal lService As Long, _
    ByVal lFlags As Long, ByVal lContext As Long) As Long
    
'Rename File at Server
Public Declare Function FtpRenameFile Lib "wininet.dll" Alias "FtpRenameFileA" _
    (ByVal hFtpSession As Long, ByVal sExisitingName As String, ByVal sNewName As String) _
    As Boolean
    
'Get File from Server
Public Declare Function FtpGetFile Lib "wininet.dll" Alias "FtpGetFileA" _
    (ByVal hFtpSession As Long, ByVal lpszRemoteFile As String, _
    ByVal lpszNewFile As String, ByVal fFailIfExists As Boolean, ByVal dwFlagsAndAttributes As Long, _
    ByVal dwFlags As Long, ByVal dwContext As Long) As Boolean
    
'Put File To Server
Public Declare Function FtpPutFile Lib "wininet.dll" Alias "FtpPutFileA" _
    (ByVal hFtpSession As Long, ByVal lpszLocalFile As String, _
    ByVal lpszRemoteFile As String, _
    ByVal dwFlags As Long, ByVal dwContext As Long) As Boolean
    
'Create Directory at Server
Public Declare Function FtpCreateDirectory Lib "wininet.dll" Alias "FtpCreateDirectoryA" _
    (ByVal hFtpSession As Long, ByVal lpszDirectory As String) As Boolean
    
'Delete file from Server
Public Declare Function FtpDeleteFile Lib "wininet.dll" _
    Alias "FtpDeleteFileA" (ByVal hFtpSession As Long, _
    ByVal lpszFileName As String) As Boolean
    
'Set current Working Directory at Server
Public Declare Function FtpSetCurrentDirectory Lib "wininet.dll" Alias "FtpSetCurrentDirectoryA" _
    (ByVal hFtpSession As Long, ByVal lpszDirectory As String) As Boolean

' To Get Windows Error Messages
Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" _
    (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, _
    ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, _
    Arguments As Long) As Long


'*******************************************************************************
'  Function Name            TranslateErrorCode
'  Input Parameters         lErrorCode
'  Output parameters        None
'  Return Values            String containg Error Desc
'  Description              Provides message corresponding to DLL error codes
'  Author                   Sumeet Ahuja
'*******************************************************************************
Public Function TranslateErrorCode(ByVal lErrorCode As Long) As String
     Select Case lErrorCode
         Case 12001: TranslateErrorCode = "No more handles could be generated at this time"
         Case 12002: TranslateErrorCode = "The request has timed out."
         Case 12003: TranslateErrorCode = "An extended error was returned from the server."
         Case 12004: TranslateErrorCode = "An internal error has occurred."
         Case 12005: TranslateErrorCode = "The URL is invalid."
         Case 12006: TranslateErrorCode = "The URL scheme could not be recognized, or is not supported."
         Case 12007: TranslateErrorCode = "The server name could not be resolved."
         Case 12008: TranslateErrorCode = "The requested protocol could not be located."
         Case 12009: TranslateErrorCode = "A request to InternetQueryOption or InternetSetOption specified an invalid option value."
         Case 12010: TranslateErrorCode = "The length of an option supplied to InternetQueryOption or InternetSetOption is incorrect for the type of option specified."
         Case 12011: TranslateErrorCode = "The request option can not be set, only queried. "
         Case 12012: TranslateErrorCode = "The Win32 Internet support is being shutdown or unloaded."
         Case 12013: TranslateErrorCode = "The request to connect and login to an FTP server could not be completed because the supplied user name is incorrect."
         Case 12014: TranslateErrorCode = "The request to connect and login to an FTP server could not be completed because the supplied password is incorrect. "
         Case 12015: TranslateErrorCode = "The request to connect to and login to an FTP server failed."
         Case 12016: TranslateErrorCode = "The requested operation is invalid. "
         Case 12017: TranslateErrorCode = "The operation was canceled, usually because the handle on which the request was operating was closed before the operation completed."
         Case 12018: TranslateErrorCode = "The type of handle supplied is incorrect for this operation."
         Case 12019: TranslateErrorCode = "The requested operation can not be carried out because the handle supplied is not in the correct state."
         Case 12020: TranslateErrorCode = "The request can not be made via a proxy."
         Case 12021: TranslateErrorCode = "A required registry value could not be located. "
         Case 12022: TranslateErrorCode = "A required registry value was located but is an incorrect type or has an invalid value."
         Case 12023: TranslateErrorCode = "Direct network access cannot be made at this time. "
         Case 12024: TranslateErrorCode = "An asynchronous request could not be made because a zero context value was supplied."
         Case 12025: TranslateErrorCode = "An asynchronous request could not be made because a callback function has not been set."
         Case 12026: TranslateErrorCode = "The required operation could not be completed because one or more requests are pending."
         Case 12027: TranslateErrorCode = "The format of the request is invalid."
         Case 12028: TranslateErrorCode = "The requested item could not be located."
         Case 12029: TranslateErrorCode = "The attempt to connect to the server failed."
         Case 12030: TranslateErrorCode = "The connection with the server has been terminated."
         Case 12031: TranslateErrorCode = "The connection with the server has been reset."
         Case 12032: TranslateErrorCode = "Calls for the Win32 Internet function to redo the request."
         Case 12033: TranslateErrorCode = "The request to the proxy was invalid."
         Case 12036: TranslateErrorCode = "The request failed because the handle already exists."
         Case 12037: TranslateErrorCode = "SSL certificate date that was received from the server is bad. The certificate is expired."
         Case 12038: TranslateErrorCode = "SSL certificate common name (host name field) is incorrect. For example, if you entered www.server.com and the common name on the certificate says www.different.com."
         Case 12039: TranslateErrorCode = "The application is moving from a non-SSL to an SSL connection because of a redirect."
         Case 12040: TranslateErrorCode = "The application is moving from an SSL to an non-SSL connection because of a redirect."
         Case 12041: TranslateErrorCode = "Indicates that the content is not entirely secure. Some of the content being viewed may have come from unsecured servers."
         Case 12042: TranslateErrorCode = "The application is posting and attempting to change multiple lines of text on a server that is not secure."
         Case 12043: TranslateErrorCode = "The application is posting data to a sever that is not secure."
         Case 12110: TranslateErrorCode = "The requested operation cannot be made on the FTP session handle because an operation is already in progress."
         Case 12111: TranslateErrorCode = "The FTP operation was not completed because the session was aborted."
         Case 12130: TranslateErrorCode = "An error was detected while parsing data returned from the gopher server."
         Case 12131: TranslateErrorCode = "The request must be made for a file locator."
         Case 12132: TranslateErrorCode = "An error was detected while receiving data from the gopher server."
         Case 12133: TranslateErrorCode = "The end of the data has been reached."
         Case 12134: TranslateErrorCode = "The supplied locator is not valid."
         Case 12135: TranslateErrorCode = "The type of the locator is not correct for this operation."
         Case 12136: TranslateErrorCode = "The requested operation can only be made against a Gopher+ server or with a locator that specifies a Gopher+ operation."
         Case 12137: TranslateErrorCode = "The requested attribute could not be located."
         Case 12138: TranslateErrorCode = "The locator type is unknown."
         Case 12150: TranslateErrorCode = "The requested header could not be located."
         Case 12151: TranslateErrorCode = "The server did not return any headers."
         Case 12152: TranslateErrorCode = "The server response could not be parsed."
         Case 12153: TranslateErrorCode = "The supplied header is invalid."
         Case 12154: TranslateErrorCode = "The request made to HttpQueryInfo is invalid."
         Case 12155: TranslateErrorCode = "The header could not be added because it already exists."
         Case 12156: TranslateErrorCode = "The redirection failed because either the scheme changed"
         Case Else: TranslateErrorCode = DisplayError(lErrorCode)
    End Select
End Function

'*******************************************************************************
'  Function Name            DisplayError
'  Input Parameters         DisplayError
'  Output parameters        None
'  Return Values            String containg Error Desc
'  Description              Provides message corresponding to DLL error codes
'  Author                   Sumeet Ahuja
'*******************************************************************************
Private Function DisplayError(ByVal lErrorCode As Long) As String

   Dim sRtrnCode As String
   Dim lFlags As Long
   Dim lRet As Long

   Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
  
    sRtrnCode = Space$(256)
    lFlags = FORMAT_MESSAGE_FROM_SYSTEM

    lRet = FormatMessage(lFlags, 0, lErrorCode, 0&, sRtrnCode, 256&, 0&)
    DisplayError = IIf(Trim$(sRtrnCode) <> "", Trim$(sRtrnCode), "Unknown Error")
    
End Function

